/**********************************************************************
 *
 * buildaction.h -- building collections
 * Copyright (C) 1999  DigiLib Systems Limited, New Zealand
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *********************************************************************/


#ifndef BUILDACTION_H
#define BUILDACTION_H

#include "action.h"
#include "receptionist.h"

class buildaction : public action {
protected:
  receptionist *recpt;

public:
  buildaction ();
  virtual ~buildaction () {}

  text_t get_action_name () {return "bc";}
  void set_receptionist (receptionist *therecpt) {recpt=therecpt;}
  
  bool check_cgiargs (cgiargsinfoclass &argsinfo, cgiargsclass &args, 
		      ostream &logout);
  void get_cgihead_info (cgiargsclass &args, response_t &response,
			 text_t &response_data, ostream &logout);
  
  void define_internal_macros (const ColInfoResponse_t &collectinfo, displayclass &disp, 
			       cgiargsclass &args, recptproto *collectproto, 
			       ostream &logout);
  void define_external_macros (const ColInfoResponse_t &collectinfo, displayclass &disp, 
			       cgiargsclass &args, recptproto *collectproto, 
			       ostream &logout);
  
  bool do_action (cgiargsclass &args, const ColInfoResponse_t &collectinfo, 
		  recptproto *collectproto, displayclass &disp, 
		  outconvertclass &outconvert, ostream &textout, 
		  ostream &logout);

protected:
  bool do_newcol (cgiargsclass &args, recptproto *collectproto,
		  displayclass &disp, outconvertclass &outconvert, 
		  ostream &textout, ostream &logout);
  bool do_editcol (cgiargsclass &args, recptproto *collectproto,
		   displayclass &disp, outconvertclass &outconvert, 
		   ostream &textout, ostream &logout);
  bool do_buildcol (cgiargsclass &args, recptproto *collectproto,
		    displayclass &disp, outconvertclass &outconvert, 
		    ostream &textout, ostream &logout);
  bool do_buildstatus (cgiargsclass &args, recptproto *collectproto,
		       displayclass &disp, outconvertclass &outconvert, 
		       ostream &textout, ostream &logout);
  bool do_delcol (cgiargsclass &args, recptproto *collectproto,
		  displayclass &disp, outconvertclass &outconvert, 
		  ostream &textout, ostream &logout);
  bool do_mess (cgiargsclass &args, recptproto *collectproto,
		displayclass &disp, outconvertclass &outconvert, 
		ostream &textout, ostream &logout);

};


#endif
